package fi.aalto.data.server;

import com.prosysopc.ua.stack.builtintypes.UnsignedInteger;
import com.prosysopc.ua.server.UaServer;
import com.prosysopc.ua.stack.builtintypes.NodeId;
import com.prosysopc.ua.nodes.UaNode;
import com.prosysopc.ua.nodes.UaValueNode;

public class DataSimulation implements Runnable {
	
	double y = 0;
	double u = 0;
	boolean exit = false;
	UaServer server;
	
	public DataSimulation (UaServer server) {
		super();
		this.server = server;
	}
	
	public void run() {
		
	    try {
		    UaValueNode node = (UaValueNode)server.getNodeManagerRoot().getNode(new NodeId(2, "P300_MeasVal"));		    
	    	UaValueNode uNode = (UaValueNode)server.getNodeManagerRoot().getNode(new NodeId(2, "M200_CurCtrlVal"));		    

		    while (!exit) {
		    	u = uNode.getValue().getValue().floatValue();
		        y = 50 * Math.random() + 60 + 0.9 * u;
		        node.setValue(new Float(y));
		        Thread.sleep(100);
		    }
		} catch (Exception e) {
				System.out.println(e.getMessage());
		}
	}
	
	public void stop() {
		exit = true;
	}
}